Remove the leftovers of the old testbed cleanup
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function check_prerequisites () {
171
172     # Fail if prerequisites are not met.
173     #
174     # Functions called:
175     # - installed - Check if application is installed/present in system.
176     # - die - Print to stderr and exit.
177
178     set -exuo pipefail
179
180     if ! installed sshpass; then
181         die "Please install sshpass before continue!"
182     fi
183 }
184
185
186 function common_dirs () {
187
188     # Set global variables, create some directories (without touching content).
189
190     # Variables set:
191     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
192     # - CSIT_DIR - Path to existing root of local CSIT git repository.
193     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
194     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
195     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
196     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
197     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
198     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
199     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
200     # Directories created if not present:
201     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
202     # Functions called:
203     # - die - Print to stderr and exit.
204
205     set -exuo pipefail
206
207     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
208         die "Some error during locating of this source file."
209     }
210     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
211         die "Some error during dirname call."
212     }
213     # Current working directory could be in a different repo, e.g. VPP.
214     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
215     relative_csit_dir=$(git rev-parse --show-toplevel) || {
216         die "Git rev-parse failed."
217     }
218     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
219     popd || die "Popd failed."
220     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
221         die "Readlink failed."
222     }
223     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
224         die "Readlink failed."
225     }
226     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
227         die "Readlink failed."
228     }
229     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
230         die "Readlink failed."
231     }
232     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
233         die "Readlink failed."
234     }
235
236     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
237         die "Readlink failed."
238     }
239     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
240     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
241         die "Readlink failed."
242     }
243     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
244     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
248 }
249
250
251 function compose_pybot_arguments () {
252
253     # Variables read:
254     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
255     # - DUT - CSIT test/ subdirectory, set while processing tags.
256     # - TAGS - Array variable holding selected tag boolean expressions.
257     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
258     # - TEST_CODE - The test selection string from environment or argument.
259     # Variables set:
260     # - PYBOT_ARGS - String holding part of all arguments for pybot.
261     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
262
263     set -exuo pipefail
264
265     # No explicit check needed with "set -u".
266     PYBOT_ARGS=("--loglevel" "TRACE")
267     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
268
269     case "${TEST_CODE}" in
270         *"device"*)
271             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
272             ;;
273         *"func"*)
274             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
275             ;;
276         *"perf"*)
277             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
278             ;;
279         *)
280             die "Unknown specification: ${TEST_CODE}"
281     esac
282
283     EXPANDED_TAGS=()
284     for tag in "${TAGS[@]}"; do
285         if [[ ${tag} == "!"* ]]; then
286             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
287         else
288             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
289         fi
290     done
291 }
292
293
294 function copy_archives () {
295
296     # Create additional archive if workspace variable is set.
297     # This way if script is running in jenkins all will be
298     # automatically archived to logs.fd.io.
299     #
300     # Variables read:
301     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
302     #   Can be unset, then it speeds up manual testing.
303     # - ARCHIVE_DIR - Path to directory with content to be copied.
304     # Directories updated:
305     # - ${WORKSPACE}/archives/ - Created if does not exist.
306     #   Content of ${ARCHIVE_DIR}/ is copied here.
307     # Functions called:
308     # - die - Print to stderr and exit.
309
310     set -exuo pipefail
311
312     if [[ -n "${WORKSPACE-}" ]]; then
313         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
314         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
315     fi
316 }
317
318
319 function deactivate_docker_topology () {
320
321     # Deactivate virtual vpp-device topology by removing containers.
322     #
323     # Variables read:
324     # - NODENESS - Node multiplicity of desired testbed.
325     # - FLAVOR - Node flavor string, usually describing the processor.
326
327     set -exuo pipefail
328
329     case_text="${NODENESS}_${FLAVOR}"
330     case "${case_text}" in
331         "1n_skx" | "1n_tx2")
332             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
333             ssh="ssh root@${hostname} -p 6022"
334             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
335             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
336                 die "Topology cleanup via shim-dcr failed!"
337             }
338             ;;
339         "1n_vbox")
340             enter_mutex || die
341             clean_environment || {
342                 die "Topology cleanup locally failed!"
343             }
344             exit_mutex || die
345             ;;
346         *)
347             die "Unknown specification: ${case_text}!"
348     esac
349 }
350
351
352 function die () {
353
354     # Print the message to standard error end exit with error code specified
355     # by the second argument.
356     #
357     # Hardcoded values:
358     # - The default error message.
359     # Arguments:
360     # - ${1} - The whole error message, be sure to quote. Optional
361     # - ${2} - the code to exit with, default: 1.
362
363     set -x
364     set +eu
365     warn "${1:-Unspecified run-time error occurred!}"
366     exit "${2:-1}"
367 }
368
369
370 function die_on_pybot_error () {
371
372     # Source this fragment if you want to abort on any failed test case.
373     #
374     # Variables read:
375     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
376     # Functions called:
377     # - die - Print to stderr and exit.
378
379     set -exuo pipefail
380
381     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
382         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
383     fi
384 }
385
386
387 function generate_tests () {
388
389     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
390     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
391     # The generation is done by executing any *.py executable
392     # within any subdirectory after copying.
393
394     # This is a separate function, because this code is called
395     # both by autogen checker and entries calling run_pybot.
396
397     # Directories read:
398     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
399     # Directories replaced:
400     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
401
402     set -exuo pipefail
403
404     rm -rf "${GENERATED_DIR}/tests" || die
405     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
406     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
407     cmd_line+=("-executable" "-name" "*.py")
408     file_list=$("${cmd_line[@]}") || die
409
410     for gen in ${file_list}; do
411         directory="$(dirname "${gen}")" || die
412         filename="$(basename "${gen}")" || die
413         pushd "${directory}" || die
414         ./"${filename}" || die
415         popd || die
416     done
417 }
418
419
420 function get_test_code () {
421
422     # Arguments:
423     # - ${1} - Optional, argument of entry script (or empty as unset).
424     #   Test code value to override job name from environment.
425     # Variables read:
426     # - JOB_NAME - String affecting test selection, default if not argument.
427     # Variables set:
428     # - TEST_CODE - The test selection string from environment or argument.
429     # - NODENESS - Node multiplicity of desired testbed.
430     # - FLAVOR - Node flavor string, usually describing the processor.
431
432     set -exuo pipefail
433
434     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
435     if [[ -z "${TEST_CODE}" ]]; then
436         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
437     fi
438
439     case "${TEST_CODE}" in
440         *"1n-vbox"*)
441             NODENESS="1n"
442             FLAVOR="vbox"
443             ;;
444         *"1n-skx"*)
445             NODENESS="1n"
446             FLAVOR="skx"
447             ;;
448        *"1n-tx2"*)
449             NODENESS="1n"
450             FLAVOR="tx2"
451             ;;
452         *"2n-skx"*)
453             NODENESS="2n"
454             FLAVOR="skx"
455             ;;
456         *"3n-skx"*)
457             NODENESS="3n"
458             FLAVOR="skx"
459             ;;
460         *"2n-clx"*)
461             NODENESS="2n"
462             FLAVOR="clx"
463             ;;
464         *"2n-dnv"*)
465             NODENESS="2n"
466             FLAVOR="dnv"
467             ;;
468         *"3n-dnv"*)
469             NODENESS="3n"
470             FLAVOR="dnv"
471             ;;
472         *"3n-tsh"*)
473             NODENESS="3n"
474             FLAVOR="tsh"
475             ;;
476         *)
477             # Fallback to 3-node Haswell by default (backward compatibility)
478             NODENESS="3n"
479             FLAVOR="hsw"
480             ;;
481     esac
482 }
483
484
485 function get_test_tag_string () {
486
487     # Variables read:
488     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
489     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
490     # - TEST_CODE - The test selection string from environment or argument.
491     # Variables set:
492     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
493     #   May be empty, not set on event types not adding comment.
494
495     # TODO: ci-management scripts no longer need to perform this.
496
497     set -exuo pipefail
498
499     trigger=""
500     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
501         case "${TEST_CODE}" in
502             *"device"*)
503                 # On parsing error, ${trigger} stays empty.
504                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
505                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)' \
506                     || true)"
507                 # Set test tags as string.
508                 TEST_TAG_STRING="${trigger#$"devicetest"}"
509                 ;;
510             *"perf"*)
511                 # On parsing error, ${trigger} stays empty.
512                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
513                 # As "perftest" can be followed by something, we substitute it.
514                 comment="${comment/perftest-2n/perftest}"
515                 comment="${comment/perftest-3n/perftest}"
516                 comment="${comment/perftest-hsw/perftest}"
517                 comment="${comment/perftest-skx/perftest}"
518                 comment="${comment/perftest-dnv/perftest}"
519                 comment="${comment/perftest-tsh/perftest}"
520                 tag_string="$(echo "${comment}" \
521                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
522                 # Set test tags as string.
523                 TEST_TAG_STRING="${tag_string#$"perftest"}"
524                 ;;
525             *)
526                 die "Unknown specification: ${TEST_CODE}"
527         esac
528     fi
529 }
530
531
532 function installed () {
533
534     # Check if the given utility is installed. Fail if not installed.
535     #
536     # Duplicate of common.sh function, as this file is also used standalone.
537     #
538     # Arguments:
539     # - ${1} - Utility to check.
540     # Returns:
541     # - 0 - If command is installed.
542     # - 1 - If command is not installed.
543
544     set -exuo pipefail
545
546     command -v "${1}"
547 }
548
549
550 function reserve_and_cleanup_testbed () {
551
552     # Reserve physical testbed, perform cleanup, register trap to unreserve.
553     # When cleanup fails, remove from topologies and keep retrying
554     # until all topologies are removed.
555     #
556     # Variables read:
557     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
558     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
559     # - BUILD_TAG - Any string suitable as filename, identifying
560     #   test run executing this function. May be unset.
561     # Variables set:
562     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
563     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
564     # Functions called:
565     # - die - Print to stderr and exit.
566     # - ansible_hosts - Perform an action using ansible, see ansible.sh
567     # Traps registered:
568     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
569
570     set -exuo pipefail
571
572     while true; do
573         for topo in "${TOPOLOGIES[@]}"; do
574             set +e
575             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
576             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
577             python "${scrpt}" "${opts[@]}"
578             result="$?"
579             set -e
580             if [[ "${result}" == "0" ]]; then
581                 # Trap unreservation before cleanup check,
582                 # so multiple jobs showing failed cleanup improve chances
583                 # of humans to notice and fix.
584                 WORKING_TOPOLOGY="${topo}"
585                 echo "Reserved: ${WORKING_TOPOLOGY}"
586                 trap "untrap_and_unreserve_testbed" EXIT || {
587                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
588                     untrap_and_unreserve_testbed "${message}" || {
589                         die "Teardown should have died, not failed."
590                     }
591                     die "Trap attempt failed, unreserve succeeded. Aborting."
592                 }
593                 # Cleanup check.
594                 set +e
595                 ansible_hosts "cleanup"
596                 result="$?"
597                 set -e
598                 if [[ "${result}" == "0" ]]; then
599                     break
600                 fi
601                 warn "Testbed cleanup failed: ${topo}"
602                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
603             fi
604             # Else testbed is accessible but currently reserved, moving on.
605         done
606
607         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
608             # Exit the infinite while loop if we made a reservation.
609             warn "Reservation and cleanup successful."
610             break
611         fi
612
613         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
614             die "Run out of operational testbeds!"
615         fi
616
617         # Wait ~3minutes before next try.
618         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
619             die "Sleep time calculation failed."
620         }
621         echo "Sleeping ${sleep_time}"
622         sleep "${sleep_time}" || die "Sleep failed."
623     done
624 }
625
626
627 function run_pybot () {
628
629     # Run pybot with options based on input variables. Create output_info.xml
630     #
631     # Variables read:
632     # - CSIT_DIR - Path to existing root of local CSIT git repository.
633     # - ARCHIVE_DIR - Path to store robot result files in.
634     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
635     # - GENERATED_DIR - Tests are assumed to be generated under there.
636     # Variables set:
637     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
638     # Functions called:
639     # - die - Print to stderr and exit.
640
641     set -exuo pipefail
642
643     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
644     all_options+=("--noncritical" "EXPECTED_FAILING")
645     all_options+=("${EXPANDED_TAGS[@]}")
646
647     pushd "${CSIT_DIR}" || die "Change directory operation failed."
648     set +e
649     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
650     PYBOT_EXIT_STATUS="$?"
651     set -e
652
653     # Generate INFO level output_info.xml for post-processing.
654     all_options=("--loglevel" "INFO")
655     all_options+=("--log" "none")
656     all_options+=("--report" "none")
657     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
658     all_options+=("${ARCHIVE_DIR}/output.xml")
659     rebot "${all_options[@]}" || true
660     popd || die "Change directory operation failed."
661 }
662
663
664 function select_arch_os () {
665
666     # Set variables affected by local CPU architecture and operating system.
667     #
668     # Variables set:
669     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
670     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
671     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
672
673     set -exuo pipefail
674
675     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
676         die "Get OS release failed."
677     }
678
679     case "${os_id}" in
680         "ubuntu"*)
681             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
682             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
683             PKG_SUFFIX="deb"
684             ;;
685         "centos"*)
686             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
687             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
688             PKG_SUFFIX="rpm"
689             ;;
690         *)
691             die "Unable to identify distro or os from ${os_id}"
692             ;;
693     esac
694
695     arch=$(uname -m) || {
696         die "Get CPU architecture failed."
697     }
698
699     case "${arch}" in
700         "aarch64")
701             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
702             ;;
703         *)
704             ;;
705     esac
706 }
707
708
709 function select_tags () {
710
711     # Variables read:
712     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
713     # - TEST_CODE - String affecting test selection, usually jenkins job name.
714     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
715     #   Can be unset.
716     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
717     # - BASH_FUNCTION_DIR - Directory with input files to process.
718     # Variables set:
719     # - TAGS - Array of processed tag boolean expressions.
720
721     set -exuo pipefail
722
723     # NIC SELECTION
724     start_pattern='^  TG:'
725     end_pattern='^ \? \?[A-Za-z0-9]\+:'
726     # Remove the TG section from topology file
727     sed_command="/${start_pattern}/,/${end_pattern}/d"
728     # All topologies DUT NICs
729     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
730                 | grep -hoP "model: \K.*" | sort -u)
731     # Selected topology DUT NICs
732     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
733                | grep -hoP "model: \K.*" | sort -u)
734     # All topologies DUT NICs - Selected topology DUT NICs
735     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
736         die "Computation of excluded NICs failed."
737     }
738
739     # Select default NIC tag.
740     case "${TEST_CODE}" in
741         *"3n-dnv"* | *"2n-dnv"*)
742             default_nic="nic_intel-x553"
743             ;;
744         *"3n-tsh"*)
745             default_nic="nic_intel-x520-da2"
746             ;;
747         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
748             default_nic="nic_intel-xxv710"
749             ;;
750         *"3n-hsw"* | *"mrr-daily-master")
751             default_nic="nic_intel-xl710"
752             ;;
753         *)
754             default_nic="nic_intel-x710"
755             ;;
756     esac
757
758     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
759     # Tag file directory shorthand.
760     tfd="${BASH_FUNCTION_DIR}"
761     case "${TEST_CODE}" in
762         # Select specific performance tests based on jenkins job type variable.
763         *"ndrpdr-weekly"* )
764             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
765             ;;
766         *"mrr-daily"* )
767             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
768                 ${tfd}/mrr-daily-${FLAVOR}.txt) || die
769             ;;
770         *"mrr-weekly"* )
771             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
772             ;;
773         * )
774             if [[ -z "${TEST_TAG_STRING-}" ]]; then
775                 # If nothing is specified, we will run pre-selected tests by
776                 # following tags.
777                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
778                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
779                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
780                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
781                                 "!dot1q" "!drv_avf")
782             else
783                 # If trigger contains tags, split them into array.
784                 test_tag_array=(${TEST_TAG_STRING//:/ })
785             fi
786             ;;
787     esac
788
789     # Blacklisting certain tags per topology.
790     #
791     # Reasons for blacklisting:
792     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
793     # TODO: Add missing reasons here (if general) or where used (if specific).
794     case "${TEST_CODE}" in
795         *"2n-skx"*)
796             test_tag_array+=("!ipsechw")
797             ;;
798         *"3n-skx"*)
799             test_tag_array+=("!ipsechw")
800             # Not enough nic_intel-xxv710 to support double link tests.
801             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
802             ;;
803         *"2n-clx"*)
804             test_tag_array+=("!ipsechw")
805             ;;
806         *"2n-dnv"*)
807             test_tag_array+=("!ipsechw")
808             test_tag_array+=("!memif")
809             test_tag_array+=("!srv6_proxy")
810             test_tag_array+=("!vhost")
811             test_tag_array+=("!vts")
812             test_tag_array+=("!drv_avf")
813             ;;
814         *"3n-dnv"*)
815             test_tag_array+=("!memif")
816             test_tag_array+=("!srv6_proxy")
817             test_tag_array+=("!vhost")
818             test_tag_array+=("!vts")
819             test_tag_array+=("!drv_avf")
820             ;;
821         *"3n-tsh"*)
822             # 3n-tsh only has x520 NICs which don't work with AVF
823             test_tag_array+=("!drv_avf")
824             test_tag_array+=("!ipsechw")
825             ;;
826         *"3n-hsw"*)
827             # TODO: Introduce NOIOMMU version of AVF tests.
828             # TODO: Make (both) AVF tests work on Haswell,
829             # or document why (some of) it is not possible.
830             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
831             test_tag_array+=("!drv_avf")
832             # All cards have access to QAT. But only one card (xl710)
833             # resides in same NUMA as QAT. Other cards must go over QPI
834             # which we do not want to even run.
835             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
836             ;;
837         *)
838             # Default to 3n-hsw due to compatibility.
839             test_tag_array+=("!drv_avf")
840             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
841             ;;
842     esac
843
844     # We will add excluded NICs.
845     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
846
847     TAGS=()
848
849     # We will prefix with perftest to prevent running other tests
850     # (e.g. Functional).
851     prefix="perftestAND"
852     set +x
853     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
854         # Automatic prefixing for VPP jobs to limit the NIC used and
855         # traffic evaluation to MRR.
856         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
857             prefix="${prefix}mrrAND"
858         else
859             prefix="${prefix}mrrAND${default_nic}AND"
860         fi
861     fi
862     for tag in "${test_tag_array[@]}"; do
863         if [[ "${tag}" == "!"* ]]; then
864             # Exclude tags are not prefixed.
865             TAGS+=("${tag}")
866         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
867             # Badly formed tag expressions can trigger way too much tests.
868             set -x
869             warn "The following tag expression hints at bad trigger: ${tag}"
870             warn "Possible cause: Multiple triggers in a single comment."
871             die "Aborting to avoid triggering too many tests."
872         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
873             # Empty and comment lines are skipped.
874             # Other lines are normal tags, they are to be prefixed.
875             TAGS+=("${prefix}${tag}")
876         fi
877     done
878     set -x
879 }
880
881
882 function select_topology () {
883
884     # Variables read:
885     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
886     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
887     # - CSIT_DIR - Path to existing root of local CSIT git repository.
888     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
889     # Variables set:
890     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
891     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
892     # Functions called:
893     # - die - Print to stderr and exit.
894
895     set -exuo pipefail
896
897     case_text="${NODENESS}_${FLAVOR}"
898     case "${case_text}" in
899         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
900         # TODO: Double link availability depends on NIC used.
901         "1n_vbox")
902             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
903             TOPOLOGIES_TAGS="2_node_single_link_topo"
904             ;;
905         "1n_skx" | "1n_tx2")
906             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
907             TOPOLOGIES_TAGS="2_node_single_link_topo"
908             ;;
909         "2n_skx")
910             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
911             TOPOLOGIES_TAGS="2_node_*_link_topo"
912             ;;
913         "3n_skx")
914             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
915             TOPOLOGIES_TAGS="3_node_*_link_topo"
916             ;;
917         "2n_clx")
918             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
919             TOPOLOGIES_TAGS="2_node_*_link_topo"
920             ;;
921         "2n_dnv")
922             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
923             TOPOLOGIES_TAGS="2_node_single_link_topo"
924             ;;
925         "3n_dnv")
926             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
927             TOPOLOGIES_TAGS="3_node_single_link_topo"
928             ;;
929         "3n_hsw")
930             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
931             TOPOLOGIES_TAGS="3_node_single_link_topo"
932             ;;
933         "3n_tsh")
934             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
935             TOPOLOGIES_TAGS="3_node_single_link_topo"
936             ;;
937         *)
938             # No falling back to 3n_hsw default, that should have been done
939             # by the function which has set NODENESS and FLAVOR.
940             die "Unknown specification: ${case_text}"
941     esac
942
943     if [[ -z "${TOPOLOGIES-}" ]]; then
944         die "No applicable topology found!"
945     fi
946 }
947
948
949 function select_vpp_device_tags () {
950
951     # Variables read:
952     # - TEST_CODE - String affecting test selection, usually jenkins job name.
953     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
954     #   Can be unset.
955     # Variables set:
956     # - TAGS - Array of processed tag boolean expressions.
957
958     set -exuo pipefail
959
960     case "${TEST_CODE}" in
961         # Select specific device tests based on jenkins job type variable.
962         * )
963             if [[ -z "${TEST_TAG_STRING-}" ]]; then
964                 # If nothing is specified, we will run pre-selected tests by
965                 # following tags. Items of array will be concatenated by OR
966                 # in Robot Framework.
967                 test_tag_array=()
968             else
969                 # If trigger contains tags, split them into array.
970                 test_tag_array=(${TEST_TAG_STRING//:/ })
971             fi
972             ;;
973     esac
974
975     # Blacklisting certain tags per topology.
976     #
977     # Reasons for blacklisting:
978     # - avf - AVF is not possible to run on enic driver of VirtualBox.
979     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
980     case "${TEST_CODE}" in
981         *"1n-vbox"*)
982             test_tag_array+=("!avf")
983             test_tag_array+=("!vhost")
984             ;;
985         *)
986             ;;
987     esac
988
989     TAGS=()
990
991     # We will prefix with devicetest to prevent running other tests
992     # (e.g. Functional).
993     prefix="devicetestAND"
994     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
995         # Automatic prefixing for VPP jobs to limit testing.
996         prefix="${prefix}"
997     fi
998     for tag in "${test_tag_array[@]}"; do
999         if [[ ${tag} == "!"* ]]; then
1000             # Exclude tags are not prefixed.
1001             TAGS+=("${tag}")
1002         else
1003             TAGS+=("${prefix}${tag}")
1004         fi
1005     done
1006 }
1007
1008 function untrap_and_unreserve_testbed () {
1009
1010     # Use this as a trap function to ensure testbed does not remain reserved.
1011     # Perhaps call directly before script exit, to free testbed for other jobs.
1012     # This function is smart enough to avoid multiple unreservations (so safe).
1013     # Topo cleanup is executed (call it best practice), ignoring failures.
1014     #
1015     # Hardcoded values:
1016     # - default message to die with if testbed might remain reserved.
1017     # Arguments:
1018     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1019     # Variables read (by inner function):
1020     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1021     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1022     # Variables written:
1023     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1024     # Trap unregistered:
1025     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1026     # Functions called:
1027     # - die - Print to stderr and exit.
1028     # - ansible_hosts - Perform an action using ansible, see ansible.sh
1029
1030     set -xo pipefail
1031     set +eu  # We do not want to exit early in a "teardown" function.
1032     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1033     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1034     if [[ -z "${wt-}" ]]; then
1035         set -eu
1036         warn "Testbed looks unreserved already. Trap removal failed before?"
1037     else
1038         ansible_hosts "cleanup" || true
1039         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1040             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1041         }
1042         WORKING_TOPOLOGY=""
1043         set -eu
1044     fi
1045 }
1046
1047
1048 function warn () {
1049
1050     # Print the message to standard error.
1051     #
1052     # Arguments:
1053     # - ${@} - The text of the message.
1054
1055     set -exuo pipefail
1056
1057     echo "$@" >&2
1058 }